#include "matrix.h"
#include "fill.h"

// Sigo con la convención (y,x)
static int MEvoy[9][2] = {{0,0}, {-1, 0}, {-1, 1}, {0, 1}, {1,1}, {1, 0}, {1,-1}, {0,-1}, {-1,-1} }; 

int signedArea( int p1, int p2 )
{
	return( MEvoy[p1][1]*MEvoy[p2][0] - MEvoy[p1][0]*MEvoy[p2][1] ); 
}

void follow_perimeter( MATRIX *I, int y, int x, byte tono  )
{
	int i, j, k, P[9], Porden[9];
	int vecinos[8];
	byte *inptr, **pimg;

	pimg = (byte **) I->ptr;

	do {
		printf( "%d %d\n", x, y );

		// El punto inicial del perímetro es y, x
		for ( k=0, i = -1 ; i <= 1; i++ ) {
			inptr = (unsigned char *) I->ptr[ y+i ];
			inptr = inptr + x - 1;
			for ( j = 0 ; j < 3; j++ ){
				P[k++] =  ( *inptr++ == tono ) ? 1 : 0;
			}
		}

		Porden[0] = P[4]; Porden[1] = P[1]; Porden[2] = P[2];
		Porden[3] = P[5]; Porden[4] = P[8]; Porden[5] = P[7];
		Porden[6] = P[6]; Porden[7] = P[3]; Porden[8] = P[0];

		for( k=0, i=1; i<9; i++ ) 
			if( Porden[i] )
				vecinos[k++] = i;

		// printf( "%d vecinos\n", k );

		// El punto (y,x) tiene k vecinos
		// Si k=1, borramos (y,x) y nos vamos a ese vecino
		// Si k=2, los ordenamos, borramos (y,x) y nos vamos al siguiente punto
		// Si k=3, los ordenamos, borramos (y,x) y nos vamos al siguiente punto
		// Si k>=4, es un error?
		if ( k==0 ) {
			break;  // Ya no hay puntos del perímetro, salimos del ciclo do-while
		}
		else if ( k==1 ) {
			goto AQUI;
		}
		else if ( k==2 ) {
			// Ordenos los puntos (y,x), vecinos[1] y vecinos[2]
			// printf( "%d %d\n", vecinos[0], vecinos[1] );
			if ( signedArea( vecinos[0], vecinos[1] ) > 0 ) {
				k = vecinos[0];
				vecinos[0] = vecinos[1];
				vecinos[1] = k;
			}
		}
		else if ( k==3 ) {
			// Ordenos los puntos (y,x), vecinos[1] y vecinos[2]
			// Ordenos los puntos (y,x), vecinos[2] y vecinos[3]
			// Ordenos los puntos (y,x), vecinos[1] y vecinos[2]
			if ( signedArea( vecinos[0], vecinos[1] ) > 0 ) {
				k = vecinos[0];
				vecinos[0] = vecinos[1];
				vecinos[1] = k;
			}
			if ( signedArea( vecinos[1], vecinos[2] ) > 0 ) {
				k = vecinos[1];
				vecinos[1] = vecinos[2];
				vecinos[2] = k;
			}
			if ( signedArea( vecinos[0], vecinos[1] ) > 0 ) {
				k = vecinos[0];
				vecinos[0] = vecinos[1];
				vecinos[1] = k;
			}
		}
		else  {
			fprintf( stderr, "Esto ocurre en un perímetro???\n" );
			return;
		}
		AQUI:
		// Borro el pixel (y,x)
		pimg[y][x] = 255;	
		y += MEvoy[ vecinos[0] ][0];
		x += MEvoy[ vecinos[0] ][1];
	} while( 1 );
}
