#include "matrix.h"
#include "morphology.h"
#include "fill.h"

/** 
	Dilation of an object
	The resul is save in the same input image
	backgroud = tono
	object = 255
**/
void dilation_4neig_inplace_obj( MATRIX *I, int *v, byte tono )
{
	int i, j;
	byte *ptrin;
	byte **pimg;
	int val;

	// El "borde" a 255
	ptrin = (byte *) I->ptr[ v[INICIOY] - 1 ] + v[INICIOX] - 1;
	for( j=v[INICIOX]-1; j<=v[FINX]+1; j++ )
		*ptrin++ = 255;

	for( i=v[INICIOY]; i<=v[FINY]; i++ ) {
		ptrin = (byte *) I->ptr[i] + v[INICIOX] - 1;
		*ptrin = 255;
		ptrin = (byte *) I->ptr[i] + v[FINX] + 1;
		*ptrin = 255;
	}

	ptrin = (byte *) I->ptr[ v[FINY] + 1 ] + v[INICIOX] - 1;
	for( j=v[INICIOX]-1; j<=v[FINX]+1; j++ )
		*ptrin++ = 255;

	// Fin de poner orden. Ok

	pimg = (byte **) I->ptr;
	for( i=v[INICIOY]; i<=v[FINY]; i++ ) {
		ptrin = (byte *) I->ptr[i] + v[INICIOX];
		for( j=v[INICIOX]; j<=v[FINX]; j++ ) {
			if ( *ptrin == tono ) {
				val = 0;
				if ( pimg[i-1][j] == 255 ) val = 255; 
				if ( pimg[i][j-1] == 255 ) val = 255; 
				if ( pimg[i][j+1] == 255 ) val = 255; 
				if ( pimg[i+1][j] == 255 ) val = 255; 

				if ( val == 255 )
					pimg[i][j] = 254;
			}
			ptrin++;
		}
	}
}


void erosion_3x3_obj( MATRIX *IN, int *v, byte tono, MATRIX *OUT )
{
	int i, j, l, k;
	byte *ptrin, *ptrout;
	int val;

    //Limpia la salida 
	/**
	for( i=v[INICIOY]; i<=v[FINY]; i++ ) {
		ptrout = (byte *) OUT->ptr[i] + v[INICIOX];
		for( j=v[INICIOX]; j<=v[FINX]; j++ )
			*ptrout++ = 0;
	}
	**/

	for( i=v[INICIOY]-1; i<=v[FINY] - 2; i++ ) {
		ptrout = (byte *) OUT->ptr[i+1] + v[INICIOX];
		for( j=v[INICIOX]-1; j<=v[FINX] - 2; j++ ) {
			val = tono;
			for( l=0; l<3; l++ ) { 
				ptrin = (byte *) IN->ptr[i + l] + j;
				for( k=0; k<3; k++ ) {
                        val &= *ptrin++; 
                }
			}
			if ( val == tono ) *ptrout = tono;	
			ptrout++;
		}
	}
}

void erosion_3x3_e( MATRIX *IN, MATRIX *OUT, int E[3][3] )
{
	int i, j, l, k;
	byte *ptrin, *ptrout;
	int val;

    //Limpia la salida 
	for( i=0; i<IN->rows; i++ ) {
		ptrout = (byte *) OUT->ptr[i];
		for( j=0; j<IN->cols; j++ ) *ptrout++ = 0;
	}

    //
	for( i=0; i<=IN->rows - 3; i++ ) {
		ptrout = (byte *) OUT->ptr[i+1] + 1;
		for( j=0; j<=IN->cols - 3; j++ ) {
			val = 0xff;
			for( l=0; l<3; l++ ) { 
				ptrin = (byte *) IN->ptr[i + l] + j;
				for( k=0; k<3; k++ ) {
                    if (E[l][k] == 1) 
                        val &= *ptrin++; 
                }
			}
			if ( val ) *ptrout = 255;	
			ptrout++;
		}
	}
}

void restaA_B_obj( MATRIX *A, int *v, byte tono, MATRIX *B, MATRIX *OUT )
{
    byte * aptr;
    byte * bptr; 
    byte * optr;
    int i, j, v1, v2;

	v2 = 255 - tono;
    for ( i = v[INICIOY]; i <= v[FINY]; i++ ){
        aptr= (byte *) A->ptr[i] + v[INICIOX];
        bptr= (byte *) B->ptr[i] + v[INICIOX];
        optr= (byte *) OUT->ptr[i] + v[INICIOX];
       	for( j = v[INICIOX]; j <= v[FINX]; j++ ){
			v1 = *aptr++ - *bptr++;
			if ( v1 == 0 ) 
				*optr = 255;
			else if ( v1 == v2 )
				*optr = tono;
			else
				*optr = 255;
			optr++;
       	}
    }
}

void restaA_B(MATRIX *A , MATRIX *B, MATRIX *OUT){
    byte * aptr;
    byte * bptr; 
    byte * optr;
    int i ,j;
    for (i = 0; i < A->rows; i++){
        aptr= (byte *) A->ptr[i];
        bptr= (byte *) B->ptr[i];
        optr= (byte *) OUT->ptr[i];
       	for(j = 0 ; j< A->cols; j++){
            optr[j] =  (aptr[j] == bptr[j]) ? 0 : 255;
       	}
    }
}


void erosion_3x3( MATRIX *IN, MATRIX *OUT )
{
	int i, j, l, k;
	byte *ptrin, *ptrout;
	int val;

    //Limpia la salida 
	for( i=0; i<IN->rows; i++ ) {
		ptrout = (byte *) OUT->ptr[i];
		for( j=0; j<IN->cols; j++ ) *ptrout++ = 0;
	}

    //
	for( i=0; i<=IN->rows - 3; i++ ) {
		ptrout = (byte *) OUT->ptr[i+1] + 1;
		for( j=0; j<=IN->cols - 3; j++ ) {
			val = 0xff;
			for( l=0; l<3; l++ ) { 
				ptrin = (byte *) IN->ptr[i + l] + j;
				for( k=0; k<3; k++ ) val &= *ptrin++; 
			}
			if ( val ) *ptrout = 255;	
			ptrout++;
		}
	}
}

void dilation_3x3_obj( MATRIX *IN, int *v, byte tono, MATRIX *OUT )
{
	int i, j, l, k;
	byte *ptrin, *ptrout;
	int val;

	// AQUI
	ptrin = (byte *) IN->ptr[v[INICIOY]-1] + v[INICIOX]  - 1;
	for( j=v[INICIOX]-1; j<=v[FINX]+1; j++ )
			*ptrin++ = 255;

	for( i=v[INICIOY]; i<=v[FINY]; i++ ) {
		ptrin = (byte *) IN->ptr[i] + v[INICIOX] - 1;
		*ptrin = 255;
		ptrin = (byte *) IN->ptr[i] + v[INICIOX] + v[FINX] + 1 ;
		*ptrin = 255;
	}
	ptrin = (byte *) IN->ptr[v[FINY]+1] + v[INICIOX]  - 1;
	for( j=v[INICIOX]-1; j<=v[FINX]+1; j++ )
			*ptrin++ = 255;


	for( i=v[INICIOY]; i<=v[FINY]; i++ ) {
		ptrout = (byte *) OUT->ptr[i] + v[INICIOX];
		for( j=v[INICIOX]; j<=v[FINX]; j++ )
			*ptrout++ = tono;
	}

	for( i=v[INICIOY]-1; i<=v[FINY] - 1; i++ ) {
		ptrout = (byte *) OUT->ptr[i+1] + v[INICIOX];
		for( j=v[INICIOX]-1; j<=v[FINX] - 1; j++ ) {
			val = 0;
			for( l=0; l<3; l++ ) { 
				ptrin = (byte *) IN->ptr[i + l] + j;
				for( k=0; k<3; k++ ) val |= *ptrin++; 
			}
			if ( val == 255 ) *ptrout = 255;	
			ptrout++;
		}
	}
}

void dilation_3x3( MATRIX *IN, MATRIX *OUT )
{
	int i, j, l, k;
	byte *ptrin, *ptrout;
	int val;

	for( i=0; i<IN->rows; i++ ) {
		ptrout = (byte *) OUT->ptr[i];
		for( j=0; j<IN->cols; j++ ) *ptrout++ = 0;
	}

	for( i=0; i<=IN->rows - 3; i++ ) {
		ptrout = (byte *) OUT->ptr[i+1] + 1;
		for( j=0; j<=IN->cols - 3; j++ ) {
			val = 0;
			for( l=0; l<3; l++ ) { 
				ptrin = (byte *) IN->ptr[i + l] + j;
				for( k=0; k<3; k++ ) val |= *ptrin++; 
			}
			if ( val ) *ptrout = 255;	
			ptrout++;
		}
	}
}

void opening_3x3( MATRIX *IN, MATRIX *OUT )
{
	int i, j;
	byte *ptrin, *ptrout;

	erosion_3x3( IN, OUT );
	dilation_3x3( OUT, IN );

	/** We copy image IN to OUT **/
	for( i=0; i<IN->rows; i++ ) {
		ptrin = (byte *) IN->ptr[i];
		ptrout = (byte *) OUT->ptr[i];
		for( j=0; j<IN->cols; j++ ) *ptrout++ = *ptrin++;
	}
	/** And the resulted image is finally in OUT **/
}

void closing_3x3( MATRIX *IN, MATRIX *OUT )
{
	int i, j;
	byte *ptrin, *ptrout;

	dilation_3x3( IN, OUT );
	erosion_3x3( OUT, IN );

	/** We copy image IN to OUT **/
	for( i=0; i<IN->rows; i++ ) {
		ptrin = (byte *) IN->ptr[i];
		ptrout = (byte *) OUT->ptr[i];
		for( j=0; j<IN->cols; j++ ) *ptrout++ = *ptrin++;
	}
	/** And the resulted image is finally in OUT **/
}
